#ifndef	__MAIN_H__
#define	__MAIN_H__
//*******************************************************
//
//	Color LCD Clock	Self Programmer
//
//	ATmega1284p
//		efuse:0xFD	BOD 2.7V
//		hfuse:0xD0	JTAG禁止, EEPROM消去保護
//		lfuse:0xE2	内蔵CR発振 8MHz
//
//	Compiler:	AVR-GCC		4.3.4
//				AVR-LIBC	1.6.7
//				binutils	2.20
//
//	2011.5.24	KAWAKAMI Yukio
//*******************************************************

#include	<avr/pgmspace.h>
#include	"pff.h"

#define		VERSION		"1.1.1"

#define		F_CPU	7987200UL	// 38400 x 16 x 13

#define		CR	13
#define		LF	10
#define		TAB	9
#define		ON	1
#define		OFF	0
#define		TRUE	1
#define		FALSE	0

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;



#define ADRS_1DC00H	__attribute__ ((section (".bootsub")))
#define ADRS_1FF40H	__attribute__ ((section (".writeflash")))


#define		LED2	7	// PORTA
#define		LED1	6
#define		RSTB	5
#define		LWR		4
#define		LRD		3
#define		LRES	2
#define		LRS		1
#define		LCS		0

#define		SCK		7	// PORTB
#define		MISO	6
#define		MOSI	5
#define		SDCS	4
#define		RDATA	3
#define		RCLK	2
#define		CCE		1
#define		MCS		0

#define		LCD_DB_OUT	PORTC
#define		LCD_DB_IN	PINC

#define		BCE		6	// PORTD
#define		BR2		5
#define		BR1		4
#define		C1HZ	3
#define		RWR		2
#define		TXD		1
#define		RXD		0


// RTC-4543 レジスタ 各々4bit
#define	SEC_LOW		0
#define	SEC_HIGH	1
#define	MIN_LOW		2
#define	MIN_HIGH	3
#define	HOUR_LOW	4
#define	HOUR_HIGH	5
#define	WEEK		6
#define	DAY_LOW		7
#define	DAY_HIGH	8
#define	MONTH_LOW	9
#define	MONTH_HIGH	10
#define	YEAR_LOW	11
#define	YEAR_HIGH	12

#define	EEPROM_SELF_PROGRAM	(uint8_t *)0
#define	EEPROM_FIRM_FTIME	(uint16_t *)1	// 1,2
#define	EEPROM_FIRM_FDATE	(uint16_t *)3	// 3,4

void update_firm(void);
char verify_firm(void);
void boot(void);
void stop_interrupt(void);

void get_fdatetime(ushort *fdate, ushort *ftime);

void wait_timer(uchar tm);

#endif	// __MAIN_H__
